#ifndef _CUSTOMSLOT_H_
#define _CUSTOMSLOT_H_

#include <iostream>
#include <tqnamespace.h>
#include <tqobject.h>
#include <tqaction.h>
#include <tqdockwindow.h>
#include <tqlistview.h>
#include <tqiconview.h>
#include <tqpoint.h>
#include <tqlist.h>
#include <tqlistbox.h>
#include <tqnetworkprotocol.h>
#include <tqobject.h>
#include <tqtoolbar.h>
#include <tqwidget.h>
#include <tqcolor.h>
#include <tqdatetime.h>
#include <tqfont.h>
#include <tqrect.h>
#include <tqsize.h>
#include <tqstringlist.h>
#include <tqstring.h>
#include <tqlibrary.h>
#include <tqurlinfo.h>
#include <tqvaluelist.h>
#include <tqvariant.h>
#include <tqevent.h>
#include <tqfiledialog.h>
#include <tqmenudata.h>

class CustomSlot: public TQObject
{
	Q_OBJECT

public:

	CustomSlot (void (*ptr)(void), TQObject *parent, const char *name=0);
	CustomSlot (void (*ptr)(bool), TQObject *parent, const char *name=0);
	CustomSlot (void (*ptr)(short), TQObject *parent, const char *name=0);
	CustomSlot (void (*ptr)(int), TQObject *parent, const char *name=0);
	CustomSlot (void (*ptr)(long), TQObject *parent, const char *name=0);
	CustomSlot (void (*ptr)(float), TQObject *parent, const char *name=0);
	CustomSlot (void (*ptr)(double), TQObject *parent, const char *name=0);
	CustomSlot (void (*ptr)(const TQString&), TQObject *parent, const char *name=0);	
	CustomSlot (void (*ptr)(TQDockWindow*), TQObject *parent, const char *name=0);
	CustomSlot (void (*ptr)(TQDropEvent*), TQObject *parent, const char *name=0);
	CustomSlot (void (*ptr)(TQDropEvent*,TQListViewItem*), TQObject *parent, const char *name=0);
	CustomSlot (void (*ptr)(TQIconViewItem*), TQObject *parent, const char *name=0);
	CustomSlot (void (*ptr)(TQListBoxItem*), TQObject *parent, const char *name=0);
	CustomSlot (void (*ptr)(TQListViewItem*), TQObject *parent, const char *name=0);
	CustomSlot (void (*ptr)(TQListViewItem*,TQListViewItem*), TQObject *parent, const char *name=0);
	CustomSlot (void (*ptr)(TQListViewItem*,TQListViewItem*,TQListViewItem*), TQObject *parent, const char *name=0);
	CustomSlot (void (*ptr)(TQNetworkOperation*), TQObject *parent, const char *name=0);
	CustomSlot (void (*ptr)(TQObject*), TQObject *parent, const char *name=0);
	CustomSlot (void (*ptr)(TQToolBar*), TQObject *parent, const char *name=0);
	CustomSlot (void (*ptr)(TQWidget*), TQObject *parent, const char *name=0);
	CustomSlot (void (*ptr)(int,TQIconViewItem*), TQObject *parent, const char *name=0);
	CustomSlot (void (*ptr)(int,TQListBoxItem*), TQObject *parent, const char *name=0);
	CustomSlot (void (*ptr)(int,bool), TQObject *parent, const char *name=0);
	CustomSlot (void (*ptr)(int,int), TQObject *parent, const char *name=0);
	CustomSlot (void (*ptr)(int,int,int), TQObject *parent, const char *name=0);

public slots:
	void callback (void);
	void callback (bool);
	void callback (short);
	void callback (int);
	void callback (long);
	void callback (float);
	void callback (double);
	void callback (const TQString&);
	void callback (TQDockWindow*);
	void callback (TQDropEvent*);
	void callback (TQDropEvent*,TQListViewItem*);
	void callback (TQIconViewItem*);
	void callback (TQListBoxItem*);
	void callback (TQListViewItem*);
	void callback (TQListViewItem*,TQListViewItem*);
	void callback (TQListViewItem*,TQListViewItem*,TQListViewItem*);
	void callback (TQNetworkOperation*);
	void callback (TQObject*);
	void callback (TQToolBar*);
	void callback (TQWidget*);
	void callback (int,TQIconViewItem*);
	void callback (int,TQListBoxItem*);
	void callback (int,bool);
	void callback (int,int);
	void callback (int,int,int);

private:
	void (*p0)(void);
	void (*p1)(bool);
	void (*p2)(short);
	void (*p3)(int);
	void (*p4)(long);
	void (*p5)(float);
	void (*p6)(double);
	void (*p7)(TQDockWindow*);
	void (*p8)(TQDropEvent*);
	void (*p9)(TQDropEvent*,TQListViewItem*);
	void (*p10)(TQIconViewItem*);
	void (*p11)(TQListBoxItem*);
	void (*p12)(TQListViewItem*);
	void (*p13)(TQListViewItem*,TQListViewItem*);
	void (*p14)(TQListViewItem*,TQListViewItem*,TQListViewItem*);
	void (*p15)(TQNetworkOperation*);
	void (*p16)(TQObject*);
	void (*p17)(TQToolBar*);
	void (*p18)(TQWidget*);
	void (*p19)(int,TQIconViewItem*);
	void (*p20)(int,TQListBoxItem*);
	void (*p21)(int,bool);
	void (*p22)(int,int);
	void (*p23)(int,int,int);
	void (*p24)(const TQString&);
};

#endif // _CUSTOMSLOT_H_
