//Auto-generated by kalyptus. DO NOT EDIT.
package org.trinitydesktop.koala;

import org.trinitydesktop.qt.Qt;
import org.trinitydesktop.qt.TQMetaObject;
import org.trinitydesktop.qt.QtSupport;
import org.trinitydesktop.qt.TQWidget;

/**

 KProgressDialog provides a dialog with a text label, a progress bar
 and an optional cancel button with a KDE look 'n feel.
 Since knowing how long it can take to complete an action and it is
 undesirable to show a dialog for a split second before hiding it,
 there are a few ways to control the timing behavior of KProgressDialog.
 There is a time out that can be set before showing the dialog as well
 as an option to autohide or keep displaying the dialog once complete.
 All the functionality of KProgress is available through direct access
 to the progress bar widget via progressBar();
		@author Aaron J. Seigo

		@short A dialog with a progress bar.

*/
public class KProgressDialog extends KDialogBase  {
	protected KProgressDialog(Class dummy){super((Class) null);}
	public native TQMetaObject metaObject();
	public native String className();
	/**
		 Constructs a KProgressDialog
			@param parent Parent of the widget
			@param name Widget name
			@param caption Text to display in window title bar
			@param text Text to display in the dialog
			@param modal Set to true to make the dialog modal
		         		@short    Constructs a KProgressDialog
	*/
	public KProgressDialog(TQWidget parent, String name, String caption, String text, boolean modal) {
		super((Class) null);
		newKProgressDialog(parent,name,caption,text,modal);
	}
	private native void newKProgressDialog(TQWidget parent, String name, String caption, String text, boolean modal);
	public KProgressDialog(TQWidget parent, String name, String caption, String text) {
		super((Class) null);
		newKProgressDialog(parent,name,caption,text);
	}
	private native void newKProgressDialog(TQWidget parent, String name, String caption, String text);
	public KProgressDialog(TQWidget parent, String name, String caption) {
		super((Class) null);
		newKProgressDialog(parent,name,caption);
	}
	private native void newKProgressDialog(TQWidget parent, String name, String caption);
	public KProgressDialog(TQWidget parent, String name) {
		super((Class) null);
		newKProgressDialog(parent,name);
	}
	private native void newKProgressDialog(TQWidget parent, String name);
	public KProgressDialog(TQWidget parent) {
		super((Class) null);
		newKProgressDialog(parent);
	}
	private native void newKProgressDialog(TQWidget parent);
	public KProgressDialog() {
		super((Class) null);
		newKProgressDialog();
	}
	private native void newKProgressDialog();
	/**
		 Returns the KProgress used in this dialog.
		 To set the number of steps or other progress bar related
		 settings, access the KProgress object directly via this method.
		         		@short    Returns the KProgress used in this dialog.
	*/
	public native KProgress progressBar();
	/**
		 Sets the text in the dialog
			@param text the text to display
		         		@short    Sets the text in the dialog
	*/
	public native void setLabel(String text);
	/**
		 Returns the current dialog text
		         		@short    Returns the current dialog text
	*/
	public native String labelText();
	/**
		 Sets whether or not the user can cancel the process.
		 If the dialog is cancellable, the Cancel button will be shown
		 and the user can close the window using the window decorations.
		 If the process is not (or should not be) interuptable,
		 set the dialog to be modal and not cancellable.
			@param allowCancel Set to true to make the dialog non-closable
		         		@short    Sets whether or not the user can cancel the process.
	*/
	public native void setAllowCancel(boolean allowCancel);
	/**
		 Returns true if the dialog can be canceled, false otherwise
		         		@short    Returns true if the dialog can be canceled, false otherwise
	*/
	public native boolean allowCancel();
	/**
		 Sets whether the cancel button is visible. setAllowCancel(false)
		 implies showCancelButton(false)
			@param show Whether or not the cancel button should be shown
		         		@short    Sets whether the cancel button is visible.
	*/
	public native void showCancelButton(boolean show);
	/**
		 Sets whether the dialog should close automagically when
		 all the steps in the KProgress have been completed.
		         		@short    Sets whether the dialog should close automagically when  all the steps in the KProgress have been completed.
	*/
	public native void setAutoClose(boolean close);
	/**
		 Returns true if the dialog will close upon completion,
		 or false otherwise
		         		@short    Returns true if the dialog will close upon completion,  or false otherwise
	*/
	public native boolean autoClose();
	/**
		 Sets whether the dialog should reset the KProgress dialog
		 back to 0 steps compelete when all steps have been completed.
		 This is useful for KProgressDialogs that will be reused.
		         		@short    Sets whether the dialog should reset the KProgress dialog  back to 0 steps compelete when all steps have been completed.
	*/
	public native void setAutoReset(boolean autoReset);
	/**
		 Returns true if the KProgress widget will be reset
		 upon completion, or false otherwise
		         		@short    Returns true if the KProgress widget will be reset  upon completion, or false otherwise
	*/
	public native boolean autoReset();
	/**
		 Returns true if the dialog was closed or canceled
		 before completion. If the dialog is not cancellable
		 it will always return false.
		         		@short    Returns true if the dialog was closed or canceled  before completion.
	*/
	public native boolean wasCancelled();
	/**
		 Sets the text to appear on the cancel button.
		         		@short    Sets the text to appear on the cancel button.
	*/
	public native void setButtonText(String arg1);
	/**
		 Returns the text on the cancel button
		         		@short    Returns the text on the cancel button
	*/
	public native String buttonText();
	/**
		 Set the minimum number of milliseconds to wait before
		 actually showing the dialog
		         		@short    Set the minimum number of milliseconds to wait before  actually showing the dialog
	*/
	public native void setMinimumDuration(int ms);
	/**
		 Returns the wait duration in milliseconds
		         		@short    Returns the wait duration in milliseconds
	*/
	public native int minimumDuration();
	protected native void slotAutoShow();
	protected native void slotAutoActions(int percentage);
	protected native void slotCancel();
	/** Deletes the wrapped C++ instance */
	protected native void finalize() throws InternalError;
	/** Delete the wrapped C++ instance ahead of finalize() */
	public native void dispose();
	/** Has the wrapped C++ instance been deleted? */
	public native boolean isDisposed();
}
