//Auto-generated by kalyptus. DO NOT EDIT.
package org.trinitydesktop.koala;

import org.trinitydesktop.qt.Qt;
import org.trinitydesktop.qt.QtSupport;
import org.trinitydesktop.qt.TQObject;
import java.util.ArrayList;
import org.trinitydesktop.qt.TQWidget;

/**

 Convenience methods to access all standard KDE actions.
 These actions should be used instead of hardcoding menubar and
 toolbar items.  Using these actions helps your application easily
 conform to the KDE UI Style Guide
 All of the documentation for TDEAction holds for KStdAction
 also.  When in doubt on how things work, check the TDEAction
 documention first.
 <li><b>Simple Example:</b></li>
 In general, using standard actions should be a drop in replacement
 for regular actions.  For example, if you previously had:
 <pre>
 TDEAction newAct = new TDEAction(i18n("&New"), TQIconSet(BarIcon("filenew")),
                               TDEStdAccel.shortcut(TDEStdAccel.New), this,
                               SLOT("fileNew()"), actionCollection());
 </pre>
 You could drop that and replace it with:
 <pre>
 TDEAction newAct = KStdAction.openNew(this, SLOT("fileNew()"),
                                       actionCollection());
 </pre>
 <li><b>Non-standard Usages</b></li>
 It is possible to use the standard actions in various
 non-recommended ways.  Say, for instance, you wanted to have a
 standard action (with the associated correct text and icon and
 accelerator, etc) but you didn't want it to go in the standard
 place (this is not recommended, by the way).  One way to do this is
 to simply not use the XML UI framework and plug it into wherever
 you want.  If you do want to use the XML UI framework (good!), then
 it is still possible.
 Basically, the XML building code matches names in the XML code with
 the internal names of the actions.  You can find out the internal
 names of each of the standard actions by using the stdName
 action like so: KStdAction.stdName(KStdAction.Cut) would return
 'edit_cut'.  The XML building code will match 'edit_cut' to the
 attribute in the global XML file and place your action there.
 However, you can change the internal name.  In this example, just
 do something like:
 <pre>
 KStdAction.cut(this, SLOT("editCut()"), actionCollection(), "my_cut");
 </pre>
 Now, in your local XML resource file (e.g., yourappui.rc), simply
 put 'my_cut' where you want it to go.
 Another non-standard usage concerns getting a pointer to an
 existing action if, say, you want to enable or disable the action.
 You could do it the recommended way and just grab a pointer when
 you instantiate it as in the the 'openNew' example above... or you
 could do it the hard way:
 <pre>
 TDEAction cut = actionCollection().action(KStdAction.stdName(KStdAction.Cut));
 </pre>
 Another non-standard usage concerns instantiating the action in the
 first place.  Usually, you would use the member functions as
 shown above (e.g., KStdAction.cut(this, SLOT, parent)).  You
 may, however, do this using the enums provided.  This author can't
 think of a reason why you would want to, but, hey, if you do,
 here's how:
 <pre>
 KStdAction.action(KStdAction.New, this, SLOT("fileNew()"), actionCollection());
 KStdAction.action(KStdAction.Cut, this, SLOT("editCut()"), actionCollection());
 </pre>
		@author Kurt Granroth <granroth@kde.org>

		@short    Convenience methods to access all standard KDE actions.
		@see #http://developer#kde#org/documentation/standards/kde/style/basics/index#html

*/
public class KStdAction {
	/**
		 The standard menubar and toolbar actions.
			 		@short    The standard menubar and toolbar actions.
	*/
	public static final int ActionNone = 0;
	public static final int New = 1;
	public static final int Open = 2;
	public static final int OpenRecent = 3;
	public static final int Save = 4;
	public static final int SaveAs = 5;
	public static final int Revert = 6;
	public static final int Close = 7;
	public static final int Print = 8;
	public static final int PrintPreview = 9;
	public static final int Mail = 10;
	public static final int Quit = 11;
	public static final int Undo = 12;
	public static final int Redo = 13;
	public static final int Cut = 14;
	public static final int Copy = 15;
	public static final int Paste = 16;
	public static final int SelectAll = 17;
	public static final int Deselect = 18;
	public static final int Find = 19;
	public static final int FindNext = 20;
	public static final int FindPrev = 21;
	public static final int Replace = 22;
	public static final int ActualSize = 23;
	public static final int FitToPage = 24;
	public static final int FitToWidth = 25;
	public static final int FitToHeight = 26;
	public static final int ZoomIn = 27;
	public static final int ZoomOut = 28;
	public static final int Zoom = 29;
	public static final int Redisplay = 30;
	public static final int Up = 31;
	public static final int Back = 32;
	public static final int Forward = 33;
	public static final int Home = 34;
	public static final int Prior = 35;
	public static final int Next = 36;
	public static final int Goto = 37;
	public static final int GotoPage = 38;
	public static final int GotoLine = 39;
	public static final int FirstPage = 40;
	public static final int LastPage = 41;
	public static final int AddBookmark = 42;
	public static final int EditBookmarks = 43;
	public static final int Spelling = 44;
	public static final int ShowMenubar = 45;
	public static final int ShowToolbar = 46;
	public static final int ShowStatusbar = 47;
	public static final int SaveOptions = 48;
	public static final int KeyBindings = 49;
	public static final int Preferences = 50;
	public static final int ConfigureToolbars = 51;
	public static final int Help = 52;
	public static final int HelpContents = 53;
	public static final int WhatsThis = 54;
	public static final int ReportBug = 55;
	public static final int AboutApp = 56;
	public static final int AboutKDE = 57;
	public static final int TipofDay = 58;
	public static final int ConfigureNotifications = 59;
	public static final int FullScreen = 60;
	public static final int Clear = 61;
	public static final int PasteText = 62;

	/**
		 Creates an action corresponding to the
		 KStdAction.StdAction enum.
			 		@short    Creates an action corresponding to the  KStdAction.StdAction enum.
	*/
	public static native TDEAction create(int id, String name, TQObject recvr, String slot, TDEActionCollection parent);
	public static native TDEAction create(int id, TQObject recvr, String slot, TDEActionCollection parent);
	/**
		 This will return the internal name of a given standard action.
			 		@short    This will return the internal name of a given standard action.
	*/
	public static native String name(int id);
	public static native String stdName(int act_enum);
	/**
		 Returns a list of all standard names. Used by TDEAccelManager
		 to give those heigher weight.
				@short    Returns a list of all standard names.
	*/
	public static native ArrayList stdNames();
	/**
		 Create a new document or window.
			 		@short    Create a new document or window.
	*/
	public static native TDEAction openNew(TQObject recvr, String slot, TDEActionCollection parent, String name);
	public static native TDEAction openNew(TQObject recvr, String slot, TDEActionCollection parent);
	/**
		 Open an existing file.
			 		@short    Open an existing file.
	*/
	public static native TDEAction open(TQObject recvr, String slot, TDEActionCollection parent, String name);
	public static native TDEAction open(TQObject recvr, String slot, TDEActionCollection parent);
	/**
		 Open a recently used document. The signature of the slot being called
		 is of the form slotURLSelected( KURL ).
			@param recvr object to receive slot
			@param slot The SLOT to invoke when a URL is selected. The slot's
		 signature is slotURLSelected( KURL ).
			@param parent parent widget
			@param name name of widget
			 		@short    Open a recently used document.
	*/
	public static native TDERecentFilesAction openRecent(TQObject recvr, String slot, TDEActionCollection parent, String name);
	public static native TDERecentFilesAction openRecent(TQObject recvr, String slot, TDEActionCollection parent);
	/**
		 Save the current document.
			 		@short    Save the current document.
	*/
	public static native TDEAction save(TQObject recvr, String slot, TDEActionCollection parent, String name);
	public static native TDEAction save(TQObject recvr, String slot, TDEActionCollection parent);
	/**
		 Save the current document under a different name.
					@short    Save the current document under a different name.
	*/
	public static native TDEAction saveAs(TQObject recvr, String slot, TDEActionCollection parent, String name);
	public static native TDEAction saveAs(TQObject recvr, String slot, TDEActionCollection parent);
	/**
		 Revert the current document to the last saved version
		 (essentially will undo all changes).
					@short    Revert the current document to the last saved version  (essentially will undo all changes).
	*/
	public static native TDEAction revert(TQObject recvr, String slot, TDEActionCollection parent, String name);
	public static native TDEAction revert(TQObject recvr, String slot, TDEActionCollection parent);
	/**
		 Close the current document.
					@short    Close the current document.
	*/
	public static native TDEAction close(TQObject recvr, String slot, TDEActionCollection parent, String name);
	public static native TDEAction close(TQObject recvr, String slot, TDEActionCollection parent);
	/**
		 Print the current document.
					@short    Print the current document.
	*/
	public static native TDEAction print(TQObject recvr, String slot, TDEActionCollection parent, String name);
	public static native TDEAction print(TQObject recvr, String slot, TDEActionCollection parent);
	/**
		 Show a print preview of the current document.
					@short    Show a print preview of the current document.
	*/
	public static native TDEAction printPreview(TQObject recvr, String slot, TDEActionCollection parent, String name);
	public static native TDEAction printPreview(TQObject recvr, String slot, TDEActionCollection parent);
	/**
		 Mail this document.
					@short    Mail this document.
	*/
	public static native TDEAction mail(TQObject recvr, String slot, TDEActionCollection parent, String name);
	public static native TDEAction mail(TQObject recvr, String slot, TDEActionCollection parent);
	/**
		 Quit the program.
					@short    Quit the program.
	*/
	public static native TDEAction quit(TQObject recvr, String slot, TDEActionCollection parent, String name);
	public static native TDEAction quit(TQObject recvr, String slot, TDEActionCollection parent);
	/**
		 Undo the last operation.
					@short    Undo the last operation.
	*/
	public static native TDEAction undo(TQObject recvr, String slot, TDEActionCollection parent, String name);
	public static native TDEAction undo(TQObject recvr, String slot, TDEActionCollection parent);
	/**
		 Redo the last operation.
					@short    Redo the last operation.
	*/
	public static native TDEAction redo(TQObject recvr, String slot, TDEActionCollection parent, String name);
	public static native TDEAction redo(TQObject recvr, String slot, TDEActionCollection parent);
	/**
		 Cut selected area and store it in the clipboard.
					@short    Cut selected area and store it in the clipboard.
	*/
	public static native TDEAction cut(TQObject recvr, String slot, TDEActionCollection parent, String name);
	public static native TDEAction cut(TQObject recvr, String slot, TDEActionCollection parent);
	/**
		 Copy the selected area into the clipboard.
					@short    Copy the selected area into the clipboard.
	*/
	public static native TDEAction copy(TQObject recvr, String slot, TDEActionCollection parent, String name);
	public static native TDEAction copy(TQObject recvr, String slot, TDEActionCollection parent);
	/**
		 Paste the contents of clipboard at the current mouse or cursor
		 position.
					@short    Paste the contents of clipboard at the current mouse or cursor  position.
	*/
	public static native TDEAction paste(TQObject recvr, String slot, TDEActionCollection parent, String name);
	public static native TDEAction paste(TQObject recvr, String slot, TDEActionCollection parent);
	/**
		 Paste the contents of clipboard at the current mouse or cursor
		 position. Provide a button on the toolbar with the clipboard history
		 menu if Klipper is running.
				@short    Paste the contents of clipboard at the current mouse or cursor  position.
	*/
	public static native TDEAction pasteText(TQObject recvr, String slot, TDEActionCollection parent, String name);
	public static native TDEAction pasteText(TQObject recvr, String slot, TDEActionCollection parent);
	/**
		 Clear the content of the focus widget
				@short    Clear the content of the focus widget
	*/
	public static native TDEAction clear(TQObject recvr, String slot, TDEActionCollection parent, String name);
	public static native TDEAction clear(TQObject recvr, String slot, TDEActionCollection parent);
	/**
		 Select all elements in the current document.
					@short    Select all elements in the current document.
	*/
	public static native TDEAction selectAll(TQObject recvr, String slot, TDEActionCollection parent, String name);
	public static native TDEAction selectAll(TQObject recvr, String slot, TDEActionCollection parent);
	/**
		 Deselect any selected elements in the current document.
					@short    Deselect any selected elements in the current document.
	*/
	public static native TDEAction deselect(TQObject recvr, String slot, TDEActionCollection parent, String name);
	public static native TDEAction deselect(TQObject recvr, String slot, TDEActionCollection parent);
	/**
		 Initiate a 'find' request in the current document.
					@short    Initiate a 'find' request in the current document.
	*/
	public static native TDEAction find(TQObject recvr, String slot, TDEActionCollection parent, String name);
	public static native TDEAction find(TQObject recvr, String slot, TDEActionCollection parent);
	/**
		 Find the next instance of a stored 'find'.
					@short    Find the next instance of a stored 'find'.
	*/
	public static native TDEAction findNext(TQObject recvr, String slot, TDEActionCollection parent, String name);
	public static native TDEAction findNext(TQObject recvr, String slot, TDEActionCollection parent);
	/**
		 Find a previous instance of a stored 'find'.
					@short    Find a previous instance of a stored 'find'.
	*/
	public static native TDEAction findPrev(TQObject recvr, String slot, TDEActionCollection parent, String name);
	public static native TDEAction findPrev(TQObject recvr, String slot, TDEActionCollection parent);
	/**
		 Find and replace matches.
					@short    Find and replace matches.
	*/
	public static native TDEAction replace(TQObject recvr, String slot, TDEActionCollection parent, String name);
	public static native TDEAction replace(TQObject recvr, String slot, TDEActionCollection parent);
	/**
		 View the document at its actual size.
					@short    View the document at its actual size.
	*/
	public static native TDEAction actualSize(TQObject recvr, String slot, TDEActionCollection parent, String name);
	public static native TDEAction actualSize(TQObject recvr, String slot, TDEActionCollection parent);
	/**
		 Fit the document view to the size of the current window.
					@short    Fit the document view to the size of the current window.
	*/
	public static native TDEAction fitToPage(TQObject recvr, String slot, TDEActionCollection parent, String name);
	public static native TDEAction fitToPage(TQObject recvr, String slot, TDEActionCollection parent);
	/**
		 Fit the document view to the width of the current window.
					@short    Fit the document view to the width of the current window.
	*/
	public static native TDEAction fitToWidth(TQObject recvr, String slot, TDEActionCollection parent, String name);
	public static native TDEAction fitToWidth(TQObject recvr, String slot, TDEActionCollection parent);
	/**
		 Fit the document view to the height of the current window.
					@short    Fit the document view to the height of the current window.
	*/
	public static native TDEAction fitToHeight(TQObject recvr, String slot, TDEActionCollection parent, String name);
	public static native TDEAction fitToHeight(TQObject recvr, String slot, TDEActionCollection parent);
	/**
		 Zoom in.
					@short    Zoom in.
	*/
	public static native TDEAction zoomIn(TQObject recvr, String slot, TDEActionCollection parent, String name);
	public static native TDEAction zoomIn(TQObject recvr, String slot, TDEActionCollection parent);
	/**
		 Zoom out.
					@short    Zoom out.
	*/
	public static native TDEAction zoomOut(TQObject recvr, String slot, TDEActionCollection parent, String name);
	public static native TDEAction zoomOut(TQObject recvr, String slot, TDEActionCollection parent);
	/**
		 Popup a zoom dialog.
					@short    Popup a zoom dialog.
	*/
	public static native TDEAction zoom(TQObject recvr, String slot, TDEActionCollection parent, String name);
	public static native TDEAction zoom(TQObject recvr, String slot, TDEActionCollection parent);
	/**
		 Redisplay or redraw the document.
					@short    Redisplay or redraw the document.
	*/
	public static native TDEAction redisplay(TQObject recvr, String slot, TDEActionCollection parent, String name);
	public static native TDEAction redisplay(TQObject recvr, String slot, TDEActionCollection parent);
	/**
		 Move up (web style menu).
					@short    Move up (web style menu).
	*/
	public static native TDEAction up(TQObject recvr, String slot, TDEActionCollection parent, String name);
	public static native TDEAction up(TQObject recvr, String slot, TDEActionCollection parent);
	/**
		 Move back (web style menu).
					@short    Move back (web style menu).
	*/
	public static native TDEAction back(TQObject recvr, String slot, TDEActionCollection parent, String name);
	public static native TDEAction back(TQObject recvr, String slot, TDEActionCollection parent);
	/**
		 Move forward (web style menu).
					@short    Move forward (web style menu).
	*/
	public static native TDEAction forward(TQObject recvr, String slot, TDEActionCollection parent, String name);
	public static native TDEAction forward(TQObject recvr, String slot, TDEActionCollection parent);
	/**
		 Go to the "Home" position or document.
					@short    Go to the "Home" position or document.
	*/
	public static native TDEAction home(TQObject recvr, String slot, TDEActionCollection parent, String name);
	public static native TDEAction home(TQObject recvr, String slot, TDEActionCollection parent);
	/**
		 Scroll up one page.
					@short    Scroll up one page.
	*/
	public static native TDEAction prior(TQObject recvr, String slot, TDEActionCollection parent, String name);
	public static native TDEAction prior(TQObject recvr, String slot, TDEActionCollection parent);
	/**
		 Scroll down one page.
					@short    Scroll down one page.
	*/
	public static native TDEAction next(TQObject recvr, String slot, TDEActionCollection parent, String name);
	public static native TDEAction next(TQObject recvr, String slot, TDEActionCollection parent);
	/**
		 Go to somewhere in general.
					@short    Go to somewhere in general.
	*/
	public static native TDEAction goTo(TQObject recvr, String slot, TDEActionCollection parent, String name);
	public static native TDEAction goTo(TQObject recvr, String slot, TDEActionCollection parent);
	/**
		 Go to a specific page (dialog).
					@short    Go to a specific page (dialog).
	*/
	public static native TDEAction gotoPage(TQObject recvr, String slot, TDEActionCollection parent, String name);
	public static native TDEAction gotoPage(TQObject recvr, String slot, TDEActionCollection parent);
	/**
		 Go to a specific line (dialog).
					@short    Go to a specific line (dialog).
	*/
	public static native TDEAction gotoLine(TQObject recvr, String slot, TDEActionCollection parent, String name);
	public static native TDEAction gotoLine(TQObject recvr, String slot, TDEActionCollection parent);
	/**
		 Jump to the first page.
					@short    Jump to the first page.
	*/
	public static native TDEAction firstPage(TQObject recvr, String slot, TDEActionCollection parent, String name);
	public static native TDEAction firstPage(TQObject recvr, String slot, TDEActionCollection parent);
	/**
		 Jump to the last page.
					@short    Jump to the last page.
	*/
	public static native TDEAction lastPage(TQObject recvr, String slot, TDEActionCollection parent, String name);
	public static native TDEAction lastPage(TQObject recvr, String slot, TDEActionCollection parent);
	/**
		 Add the current page to the bookmarks tree.
					@short    Add the current page to the bookmarks tree.
	*/
	public static native TDEAction addBookmark(TQObject recvr, String slot, TDEActionCollection parent, String name);
	public static native TDEAction addBookmark(TQObject recvr, String slot, TDEActionCollection parent);
	/**
		 Edit the application bookmarks.
					@short    Edit the application bookmarks.
	*/
	public static native TDEAction editBookmarks(TQObject recvr, String slot, TDEActionCollection parent, String name);
	public static native TDEAction editBookmarks(TQObject recvr, String slot, TDEActionCollection parent);
	/**
		 Pop up the spell checker.
					@short    Pop up the spell checker.
	*/
	public static native TDEAction spelling(TQObject recvr, String slot, TDEActionCollection parent, String name);
	public static native TDEAction spelling(TQObject recvr, String slot, TDEActionCollection parent);
	/**
		 Show/Hide the menubar.
					@short    Show/Hide the menubar.
	*/
	public static native TDEToggleAction showMenubar(TQObject recvr, String slot, TDEActionCollection parent, String name);
	public static native TDEToggleAction showMenubar(TQObject recvr, String slot, TDEActionCollection parent);
	/**
		 Show/Hide the statusbar.
					@short    Show/Hide the statusbar.
	*/
	public static native TDEToggleAction showStatusbar(TQObject recvr, String slot, TDEActionCollection parent, String name);
	public static native TDEToggleAction showStatusbar(TQObject recvr, String slot, TDEActionCollection parent);
	/**
		 Switch to/from full screen mode
				@short    Switch to/from full screen mode
	*/
	public static native TDEToggleFullScreenAction fullScreen(TQObject recvr, String slot, TDEActionCollection parent, TQWidget window, String name);
	public static native TDEToggleFullScreenAction fullScreen(TQObject recvr, String slot, TDEActionCollection parent, TQWidget window);
	/**
		 Display the save options dialog.
					@short    Display the save options dialog.
	*/
	public static native TDEAction saveOptions(TQObject recvr, String slot, TDEActionCollection parent, String name);
	public static native TDEAction saveOptions(TQObject recvr, String slot, TDEActionCollection parent);
	/**
		 Display the configure key bindings dialog.
			  Note that you might be able to use the pre-built KXMLGUIFactory's fuction:
		  KStdAction.keyBindings(guiFactory(), SLOT("configureShortcuts()"), actionCollection());
		        		@short    Display the configure key bindings dialog.
	*/
	public static native TDEAction keyBindings(TQObject recvr, String slot, TDEActionCollection parent, String name);
	public static native TDEAction keyBindings(TQObject recvr, String slot, TDEActionCollection parent);
	/**
		 Display the preferences/options dialog.
					@short    Display the preferences/options dialog.
	*/
	public static native TDEAction preferences(TQObject recvr, String slot, TDEActionCollection parent, String name);
	public static native TDEAction preferences(TQObject recvr, String slot, TDEActionCollection parent);
	/**
		 The Customize Toolbar dialog.
					@short    The Customize Toolbar dialog.
	*/
	public static native TDEAction configureToolbars(TQObject recvr, String slot, TDEActionCollection parent, String name);
	public static native TDEAction configureToolbars(TQObject recvr, String slot, TDEActionCollection parent);
	/**
		 The Configure Notifications dialog.
				@short    The Configure Notifications dialog.
	*/
	public static native TDEAction configureNotifications(TQObject recvr, String slot, TDEActionCollection parent, String name);
	public static native TDEAction configureNotifications(TQObject recvr, String slot, TDEActionCollection parent);
	/**
		 Display the help.
					@short    Display the help.
	*/
	public static native TDEAction help(TQObject recvr, String slot, TDEActionCollection parent, String name);
	public static native TDEAction help(TQObject recvr, String slot, TDEActionCollection parent);
	/**
		 Display the help contents.
					@short    Display the help contents.
	*/
	public static native TDEAction helpContents(TQObject recvr, String slot, TDEActionCollection parent, String name);
	public static native TDEAction helpContents(TQObject recvr, String slot, TDEActionCollection parent);
	/**
		 Trigger the What's This cursor.
					@short    Trigger the What's This cursor.
	*/
	public static native TDEAction whatsThis(TQObject recvr, String slot, TDEActionCollection parent, String name);
	public static native TDEAction whatsThis(TQObject recvr, String slot, TDEActionCollection parent);
	/**
		 Display "Tip of the Day"
				@short    Display "Tip of the Day"
	*/
	public static native TDEAction tipOfDay(TQObject recvr, String slot, TDEActionCollection parent, String name);
	public static native TDEAction tipOfDay(TQObject recvr, String slot, TDEActionCollection parent);
	/**
		 Open up the Report Bug dialog.
					@short    Open up the Report Bug dialog.
	*/
	public static native TDEAction reportBug(TQObject recvr, String slot, TDEActionCollection parent, String name);
	public static native TDEAction reportBug(TQObject recvr, String slot, TDEActionCollection parent);
	/**
		 Display the application's About box.
					@short    Display the application's About box.
	*/
	public static native TDEAction aboutApp(TQObject recvr, String slot, TDEActionCollection parent, String name);
	public static native TDEAction aboutApp(TQObject recvr, String slot, TDEActionCollection parent);
	/**
		 Display the About KDE dialog.
					@short    Display the About KDE dialog.
	*/
	public static native TDEAction aboutKDE(TQObject recvr, String slot, TDEActionCollection parent, String name);
	public static native TDEAction aboutKDE(TQObject recvr, String slot, TDEActionCollection parent);
}
