//Auto-generated by kalyptus. DO NOT EDIT.
package org.trinitydesktop.koala;

import org.trinitydesktop.qt.Qt;
import org.trinitydesktop.qt.QtSupport;

/**

 \namespace TDEStdAccel
 Convenient methods for access to the common accelerator keys in
 the key configuration. These are the standard keybindings that should
 be used in all KDE applications. They will be configurable,
 so do not hardcode the default behavior.
 If you want real configurable keybindings in your applications,
 please checkout the class TDEAccel in tdeaccel.h
		@short    \namespace TDEStdAccel  Convenient methods for access to the common accelerator keys in  the key configuration.
		@see TDEAccelShortcutList

*/
public class TDEStdAccel {
	/**
		 Defines the identifier of all standard accelerators.
		   		@short    Defines the identifier of all standard accelerators.
	*/
	public static final int AccelNone = 0;
	public static final int Open = 1;
	public static final int New = 2;
	public static final int Close = 3;
	public static final int Save = 4;
	public static final int Print = 5;
	public static final int Quit = 6;
	public static final int Undo = 7;
	public static final int Redo = 8;
	public static final int Cut = 9;
	public static final int Copy = 10;
	public static final int Paste = 11;
	public static final int SelectAll = 12;
	public static final int Deselect = 13;
	public static final int DeleteWordBack = 14;
	public static final int DeleteWordForward = 15;
	public static final int Find = 16;
	public static final int FindNext = 17;
	public static final int FindPrev = 18;
	public static final int Replace = 19;
	public static final int Home = 20;
	public static final int End = 21;
	public static final int Prior = 22;
	public static final int Next = 23;
	public static final int GotoLine = 24;
	public static final int AddBookmark = 25;
	public static final int ZoomIn = 26;
	public static final int ZoomOut = 27;
	public static final int Up = 28;
	public static final int Back = 29;
	public static final int Forward = 30;
	public static final int Reload = 31;
	public static final int PopupMenuContext = 32;
	public static final int ShowMenubar = 33;
	public static final int Help = 34;
	public static final int WhatsThis = 35;
	public static final int TextCompletion = 36;
	public static final int PrevCompletion = 37;
	public static final int NextCompletion = 38;
	public static final int SubstringCompletion = 39;
	public static final int RotateUp = 40;
	public static final int RotateDown = 41;
	public static final int TabNext = 42;
	public static final int TabPrev = 43;
	public static final int FullScreen = 44;
	public static final int BackwardWord = 45;
	public static final int ForwardWord = 46;
	public static final int BeginningOfLine = 47;
	public static final int EndOfLine = 48;
	public static final int PasteSelection = 49;
	public static final int WhatThis = WhatsThis;

	/**
		 Returns the keybinding for <code>accel.</code>
			@param id the id of the accelerator
		   		@short    Returns the keybinding for <code>accel.</code>
	*/
	public static native TDEShortcut shortcut(int id);
	/**
		 Returns a unique name for the given accel.
			@param id the id of the accelerator
				@return the unique name of the accelerator

		@short    Returns a unique name for the given accel.
	*/
	public static native String name(int id);
	/**
		 Returns a localized label for user-visible display.
			@param id the id of the accelerator
				@return a localized label for the accelerator

		@short    Returns a localized label for user-visible display.
	*/
	public static native String label(int id);
	/**
		 Returns an extended WhatsThis description for the given accelerator.
			@param id the id of the accelerator
				@return a localized description of the accelerator

		@short    Returns an extended WhatsThis description for the given accelerator.
	*/
	public static native String whatsThis(int id);
	/**
		 Return the StdAccel id of the standard accel action which
		 uses this key sequence, or AccelNone if none of them do.
		 This is used by class KKeyChooser.
			@param keySeq the key sequence to search
				@return the id of the standard accelerator, or AccelNone if there
          is none

		@short    Return the StdAccel id of the standard accel action which  uses this key sequence, or AccelNone if none of them do.
	*/
	public static native int findStdAccel(KKeySequence keySeq);
	/**
		 Returns the hardcoded default shortcut for <code>id.</code>
		 This does not take into account the user's configuration.
			@param id the id of the accelerator
				@return the default shortcut of the accelerator

		@short    Returns the hardcoded default shortcut for <code>id.</code>
	*/
	public static native TDEShortcut shortcutDefault(int id);
	/**
		 Returns the hardcoded default 3 modifier shortcut for <code>id.</code>
		 This does not take into account the user's configuration.
			@param id the id of the accelerator
				@return the default 3 modifier shortcut

		@short    Returns the hardcoded default 3 modifier shortcut for <code>id.</code>
	*/
	public static native TDEShortcut shortcutDefault3(int id);
	/**
		 Returns the hardcoded default 4 modifier shortcut for <code>id.</code>
		 This does not take into account the user's configuration.
			@param id the id of the accelerator
				@return the default 4 modifier shortcut

		@short    Returns the hardcoded default 4 modifier shortcut for <code>id.</code>
	*/
	public static native TDEShortcut shortcutDefault4(int id);
	/**
		 Open file. Default: Ctrl-o
				@return the shortcut of the standard accelerator

		@short    Open file.
	*/
	public static native TDEShortcut open();
	/**
		 Create a new document (or whatever). Default: Ctrl-n
				@return the shortcut of the standard accelerator

		@short    Create a new document (or whatever).
	*/
	public static native TDEShortcut openNew();
	/**
		 Close current document. Default: Ctrl-w
				@return the shortcut of the standard accelerator

		@short    Close current document.
	*/
	public static native TDEShortcut close();
	/**
		 Save current document. Default: Ctrl-s
				@return the shortcut of the standard accelerator

		@short    Save current document.
	*/
	public static native TDEShortcut save();
	/**
		 Print current document. Default: Ctrl-p
				@return the shortcut of the standard accelerator

		@short    Print current document.
	*/
	public static native TDEShortcut print();
	/**
		 Quit the program. Default: Ctrl-q
				@return the shortcut of the standard accelerator

		@short    Quit the program.
	*/
	public static native TDEShortcut quit();
	/**
		 Undo last operation. Default: Ctrl-z
				@return the shortcut of the standard accelerator

		@short    Undo last operation.
	*/
	public static native TDEShortcut undo();
	/**
		 Redo. Default: Shift-Ctrl-z
				@return the shortcut of the standard accelerator

		@short    Redo.
	*/
	public static native TDEShortcut redo();
	/**
		 Cut selected area and store it in the clipboard. Default: Ctrl-x
				@return the shortcut of the standard accelerator

		@short    Cut selected area and store it in the clipboard.
	*/
	public static native TDEShortcut cut();
	/**
		 Copy selected area into the clipboard. Default: Ctrl-c
				@return the shortcut of the standard accelerator

		@short    Copy selected area into the clipboard.
	*/
	public static native TDEShortcut copy();
	/**
		 Paste contents of clipboard at mouse/cursor position. Default: Ctrl-v
				@return the shortcut of the standard accelerator

		@short    Paste contents of clipboard at mouse/cursor position.
	*/
	public static native TDEShortcut paste();
	/**
		 Paste the selection at mouse/cursor position. Default: Ctrl-Shift-Insert
				@return the shortcut of the standard accelerator

		@short    Paste the selection at mouse/cursor position.
	*/
	public static native TDEShortcut pasteSelection();
	/**
		 Reload. Default: Ctrl-A
				@return the shortcut of the standard accelerator

		@short    Reload.
	*/
	public static native TDEShortcut selectAll();
	/**
		 Delete a word back from mouse/cursor position. Default: Ctrl-Backspace
				@return the shortcut of the standard accelerator

		@short    Delete a word back from mouse/cursor position.
	*/
	public static native TDEShortcut deleteWordBack();
	/**
		 Delete a word forward from mouse/cursor position. Default: Ctrl-Delete
				@return the shortcut of the standard accelerator

		@short    Delete a word forward from mouse/cursor position.
	*/
	public static native TDEShortcut deleteWordForward();
	/**
		 Find, search. Default: Ctrl-f
				@return the shortcut of the standard accelerator

		@short    Find, search.
	*/
	public static native TDEShortcut find();
	/**
		 Find/search next. Default: F3
				@return the shortcut of the standard accelerator

		@short    Find/search next.
	*/
	public static native TDEShortcut findNext();
	/**
		 Find/search previous. Default: Shift-F3
				@return the shortcut of the standard accelerator

		@short    Find/search previous.
	*/
	public static native TDEShortcut findPrev();
	/**
		 Find and replace matches. Default: Ctrl-r
				@return the shortcut of the standard accelerator

		@short    Find and replace matches.
	*/
	public static native TDEShortcut replace();
	/**
		 Zoom in. Default: Ctrl-Plus
				@return the shortcut of the standard accelerator

		@short    Zoom in.
	*/
	public static native TDEShortcut zoomIn();
	/**
		 Zoom out. Default: Ctrl-Minus
				@return the shortcut of the standard accelerator

		@short    Zoom out.
	*/
	public static native TDEShortcut zoomOut();
	/**
		 Goto beginning of the document. Default: Ctrl-Home
				@return the shortcut of the standard accelerator

		@short    Goto beginning of the document.
	*/
	public static native TDEShortcut home();
	/**
		 Goto end of the document. Default: Ctrl-End
				@return the shortcut of the standard accelerator

		@short    Goto end of the document.
	*/
	public static native TDEShortcut end();
	/**
		 Goto beginning of current line. Default: Home
				@return the shortcut of the standard accelerator

		@short    Goto beginning of current line.
	*/
	public static native TDEShortcut beginningOfLine();
	/**
		 Goto end of current line. Default: End
				@return the shortcut of the standard accelerator

		@short    Goto end of current line.
	*/
	public static native TDEShortcut endOfLine();
	/**
		 Scroll up one page. Default: Prior
				@return the shortcut of the standard accelerator

		@short    Scroll up one page.
	*/
	public static native TDEShortcut prior();
	/**
		 Scroll down one page. Default: Next
				@return the shortcut of the standard accelerator

		@short    Scroll down one page.
	*/
	public static native TDEShortcut next();
	/**
		 Go to line. Default: Ctrl+G
				@return the shortcut of the standard accelerator

		@short    Go to line.
	*/
	public static native TDEShortcut gotoLine();
	/**
		 Add current page to bookmarks. Default: Ctrl+B
				@return the shortcut of the standard accelerator

		@short    Add current page to bookmarks.
	*/
	public static native TDEShortcut addBookmark();
	/**
		 Next Tab. Default: Ctrl-<
				@return the shortcut of the standard accelerator

		@short    Next Tab.
	*/
	public static native TDEShortcut tabNext();
	/**
		 Previous Tab. Default: Ctrl.
				@return the shortcut of the standard accelerator

		@short    Previous Tab.
	*/
	public static native TDEShortcut tabPrev();
	/**
		 Full Screen Mode. Default: Ctrl+Shift+F
				@return the shortcut of the standard accelerator

		@short    Full Screen Mode.
	*/
	public static native TDEShortcut fullScreen();
	/**
		 Help the user in the current situation. Default: F1
				@return the shortcut of the standard accelerator

		@short    Help the user in the current situation.
	*/
	public static native TDEShortcut help();
	/**
		 Complete text in input widgets. Default Ctrl+E
				@return the shortcut of the standard accelerator

		@short    Complete text in input widgets.
	*/
	public static native TDEShortcut completion();
	/**
		 Iterate through a list when completion returns
		 multiple items. Default: Ctrl+Up
				@return the shortcut of the standard accelerator

		@short    Iterate through a list when completion returns  multiple items.
	*/
	public static native TDEShortcut prevCompletion();
	/**
		 Iterate through a list when completion returns
		 multiple items. Default: Ctrl+Down
				@return the shortcut of the standard accelerator

		@short    Iterate through a list when completion returns  multiple items.
	*/
	public static native TDEShortcut nextCompletion();
	/**
		 Find a string within another string or list of strings.
		 Default: Ctrl-T
				@return the shortcut of the standard accelerator

		@short    Find a string within another string or list of strings.
	*/
	public static native TDEShortcut substringCompletion();
	/**
		 Help users iterate through a list of entries. Default: Up
				@return the shortcut of the standard accelerator

		@short    Help users iterate through a list of entries.
	*/
	public static native TDEShortcut rotateUp();
	/**
		 Help users iterate through a list of entries. Default: Down
				@return the shortcut of the standard accelerator

		@short    Help users iterate through a list of entries.
	*/
	public static native TDEShortcut rotateDown();
	/**
		 popup a context menu. Default: Menu
				@return the shortcut of the standard accelerator

		@short    popup a context menu.
	*/
	public static native TDEShortcut popupMenuContext();
	/**
		 What's This button. Default: Shift+F1
				@return the shortcut of the standard accelerator

		@short    What's This button.
	*/
	public static native TDEShortcut whatsThis();
	/**
		 Reload. Default: F5
				@return the shortcut of the standard accelerator

		@short    Reload.
	*/
	public static native TDEShortcut reload();
	/**
		 Up. Default: Alt+Up
				@return the shortcut of the standard accelerator

		@short    Up.
	*/
	public static native TDEShortcut up();
	/**
		 Back. Default: Alt+Left
				@return the shortcut of the standard accelerator

		@short    Back.
	*/
	public static native TDEShortcut back();
	/**
		 Forward. Default: ALT+Right
				@return the shortcut of the standard accelerator

		@short    Forward.
	*/
	public static native TDEShortcut forward();
	/**
		 BackwardWord. Default: Ctrl+Left
				@return the shortcut of the standard accelerator

		@short    BackwardWord.
	*/
	public static native TDEShortcut backwardWord();
	/**
		 ForwardWord. Default: Ctrl+Right
				@return the shortcut of the standard accelerator

		@short    ForwardWord.
	*/
	public static native TDEShortcut forwardWord();
	/**
		 Show Menu Bar.  Default: Ctrl-M
				@return the shortcut of the standard accelerator

		@short    Show Menu Bar.
	*/
	public static native TDEShortcut showMenubar();
}
